Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 2267)
@@ -1429,7 +1429,7 @@
     if (posDistributed==elements.size()) posDistributed=0 ; // grid composed only of scalar
     
-    vector<CLocalView*> localViews ;
-    vector<CLocalView*> workflowView ;
-    vector<CDistributedView*> remoteViews ;
+    vector<shared_ptr<CLocalView>> localViews ;
+    vector<shared_ptr<CLocalView>> workflowView ;
+    vector<shared_ptr<CDistributedView>> remoteViews ;
 
     for(int i=0 ; i<elements.size() ; i++)
@@ -1462,9 +1462,9 @@
     
     // CGridClientServerRemoteConnector : workflowView is added to avoid spurious optimisation with only the fullview
-    CGridClientServerRemoteConnector gridRemoteConnector(localViews, workflowView, remoteViews, context->getIntraComm(), client->getRemoteSize()) ;
-    gridRemoteConnector.computeConnector() ;
+    auto gridRemoteConnector = make_shared<CGridClientServerRemoteConnector>(localViews, workflowView, remoteViews, context->getIntraComm(), client->getRemoteSize()) ;
+    gridRemoteConnector->computeConnector() ;
     
-    vector<CScattererConnector*> scattererConnectors ;
-    CScattererConnector* scattererConnector;
+    vector<shared_ptr<CScattererConnector>> scattererConnectors ;
+    shared_ptr<CScattererConnector> scattererConnector;
     for(int i=0 ; i<elements.size() ; i++)
     {
@@ -1472,9 +1472,9 @@
       { 
         CDomain* domain = (CDomain*) elements[i].ptr ;
-        if (isCoupling) domain->distributeToServer(client, gridRemoteConnector.getDistributedGlobalIndex(i), scattererConnector,  domain->getCouplingAlias(fieldId,i)) ;
+        if (isCoupling) domain->distributeToServer(client, gridRemoteConnector->getDistributedGlobalIndex(i), scattererConnector,  domain->getCouplingAlias(fieldId,i)) ;
         else 
         {
           sendAddDomain(domain->getId(),client) ;
-          domain->distributeToServer(client, gridRemoteConnector.getDistributedGlobalIndex(i), scattererConnector) ;
+          domain->distributeToServer(client, gridRemoteConnector->getDistributedGlobalIndex(i), scattererConnector) ;
         }
         scattererConnectors.push_back(scattererConnector) ;
@@ -1483,9 +1483,9 @@
       {
         CAxis* axis = (CAxis*) elements[i].ptr ;
-        if (isCoupling) axis->distributeToServer(client, gridRemoteConnector.getDistributedGlobalIndex(i), scattererConnector,  axis->getCouplingAlias(fieldId,i)) ;
+        if (isCoupling) axis->distributeToServer(client, gridRemoteConnector->getDistributedGlobalIndex(i), scattererConnector,  axis->getCouplingAlias(fieldId,i)) ;
         else 
         {
           sendAddAxis(axis->getId(),client) ;
-          axis->distributeToServer(client, gridRemoteConnector.getDistributedGlobalIndex(i), scattererConnector) ;
+          axis->distributeToServer(client, gridRemoteConnector->getDistributedGlobalIndex(i), scattererConnector) ;
         }
         scattererConnectors.push_back(scattererConnector) ;
@@ -1494,9 +1494,9 @@
       {
         CScalar* scalar = (CScalar*) elements[i].ptr ;
-        if (isCoupling) scalar->distributeToServer(client, gridRemoteConnector.getDistributedGlobalIndex(i), scattererConnector,  scalar->getCouplingAlias(fieldId,i)) ;
+        if (isCoupling) scalar->distributeToServer(client, gridRemoteConnector->getDistributedGlobalIndex(i), scattererConnector,  scalar->getCouplingAlias(fieldId,i)) ;
         else 
         {
           sendAddScalar(scalar->getId(),client) ;
-          scalar->distributeToServer(client, gridRemoteConnector.getDistributedGlobalIndex(i), scattererConnector) ;
+          scalar->distributeToServer(client, gridRemoteConnector->getDistributedGlobalIndex(i), scattererConnector) ;
         }
         scattererConnectors.push_back(scattererConnector) ;
@@ -1504,6 +1504,6 @@
     }
 
-    CGridScattererConnector gridScattererConnector(scattererConnectors) ;
-    CGridLocalConnector* workflowToFull = getGridLocalElements()->getConnector(CElementView::WORKFLOW, CElementView::FULL) ;
+    auto gridScattererConnector = make_shared<CGridScattererConnector>(scattererConnectors) ;
+    shared_ptr<CGridLocalConnector> workflowToFull = getGridLocalElements()->getConnector(CElementView::WORKFLOW, CElementView::FULL) ;
     CArray<bool,1> maskIn(workflowToFull->getSrcSize()) ;
     CArray<bool,1> maskOut(workflowToFull->getDstSize()) ;
@@ -1515,9 +1515,8 @@
     if (isCoupling) message<<getCouplingAlias(fieldId) ;
     else message<<getId() ; 
-    gridScattererConnector.transfer(maskOut, client, event, message) ;
-    for(auto& it : scattererConnectors) delete it ;
-
-    vector<CScattererConnector*> clientToServerConnectors ;
-    vector<CGathererConnector*>  clientFromServerConnectors ;
+    gridScattererConnector->transfer(maskOut, client, event, message) ;
+   
+    vector<shared_ptr<CScattererConnector>> clientToServerConnectors ;
+    vector<shared_ptr<CGathererConnector>>  clientFromServerConnectors ;
     for(auto& element : elements)
     {
@@ -1541,6 +1540,6 @@
     
     // compute the grid clientToServerConnector to send flux from client to servers
-    clientToServerConnector_[client] = new CGridScattererConnector(clientToServerConnectors) ;
-    clientFromServerConnector_[client] = new CGridGathererConnector(clientFromServerConnectors) ;
+    clientToServerConnector_[client] = make_shared<CGridScattererConnector>(clientToServerConnectors) ;
+    clientFromServerConnector_[client] = make_shared<CGridGathererConnector>(clientFromServerConnectors) ;
 
   }
@@ -1556,6 +1555,6 @@
   void CGrid::receiveMask(CEventServer& event)
   {
-    vector<CGathererConnector*> gathererConnectors ;
-    vector<CLocalView*> fullViews ;
+    vector<shared_ptr<CGathererConnector>> gathererConnectors ;
+    vector<shared_ptr<CLocalView>> fullViews ;
 
     for(auto& element : getElements())
@@ -1578,10 +1577,10 @@
       }
     }
-    CGridGathererConnector gridGathererConnector(gathererConnectors) ;
-    CGridMaskConnector gridMaskConnector(fullViews) ;
+    auto gridGathererConnector = make_shared<CGridGathererConnector>(gathererConnectors) ;
+    auto gridMaskConnector = make_shared<CGridMaskConnector>(fullViews) ;
 
     CArray<bool,1> maskOut ;
-    gridGathererConnector.transfer_or(event,maskOut) ;
-    gridMaskConnector.computeConnector(maskOut) ;
+    gridGathererConnector->transfer_or(event,maskOut) ;
+    gridMaskConnector->computeConnector(maskOut) ;
 
     CContextClient* client = event.getContextServer()->getAssociatedClient() ;
@@ -1589,7 +1588,7 @@
     for(auto& element : getElements())
     {
-      if (element.type==TYPE_DOMAIN) element.domain->setServerMask(gridMaskConnector.getElementMask(i),client);
-      else if (element.type==TYPE_AXIS) element.axis->setServerMask(gridMaskConnector.getElementMask(i),client);
-      else if (element.type==TYPE_SCALAR) element.scalar->setServerMask(gridMaskConnector.getElementMask(i),client);
+      if (element.type==TYPE_DOMAIN) element.domain->setServerMask(gridMaskConnector->getElementMask(i),client);
+      else if (element.type==TYPE_AXIS) element.axis->setServerMask(gridMaskConnector->getElementMask(i),client);
+      else if (element.type==TYPE_SCALAR) element.scalar->setServerMask(gridMaskConnector->getElementMask(i),client);
       i++ ;
     }
@@ -2310,5 +2309,5 @@
     auto axis=axisList.begin() ;
     auto scalar=scalarList.begin() ;
-    vector<CLocalElement*> elements;
+    vector<shared_ptr<CLocalElement>> elements;
     for(auto order : order_)
     {
@@ -2332,7 +2331,7 @@
     {
       vector<bool> mask(getMask().getVector()) ;
-      gridLocalElements_ = new CGridLocalElements(elements, mask) ;  
-    }
-    else gridLocalElements_ = new CGridLocalElements(elements) ;  
+      gridLocalElements_ = make_shared<CGridLocalElements>(elements, mask) ;  
+    }
+    else gridLocalElements_ = make_shared<CGridLocalElements>(elements) ;  
   }
 
@@ -2359,5 +2358,5 @@
   void CGrid::computeServerFromClientConnector(void)
   {
-    vector<CGathererConnector*> connectors ;
+    vector<shared_ptr<CGathererConnector>> connectors ;
     for(auto& element : getElements())
     {
@@ -2366,10 +2365,10 @@
       else if (element.type==TYPE_SCALAR) connectors.push_back(element.scalar->getServerFromClientConnector()) ; 
     }
-    serverFromClientConnector_ = new CGridGathererConnector(connectors) ;
+    serverFromClientConnector_ = make_shared<CGridGathererConnector>(connectors) ;
   }
 
   void CGrid::computeServerToClientConnector(void)
   {
-    vector<CScattererConnector*> connectors ;
+    vector<shared_ptr<CScattererConnector>> connectors ;
     for(auto& element : getElements())
     {
@@ -2378,10 +2377,10 @@
       else if (element.type==TYPE_SCALAR) connectors.push_back(element.scalar->getServerToClientConnector()) ; 
     }
-    serverToClientConnector_ = new CGridScattererConnector(connectors) ;
+    serverToClientConnector_ = make_shared<CGridScattererConnector>(connectors) ;
   }
 
   void CGrid::computeClientFromClientConnector(void)
   {
-    vector<CGathererConnector*> connectors ;
+    vector<shared_ptr<CGathererConnector>> connectors ;
     for(auto& element : getElements())
     {
@@ -2390,5 +2389,5 @@
       else if (element.type==TYPE_SCALAR) connectors.push_back(element.scalar->getServerFromClientConnector()) ; 
     }
-    clientFromClientConnector_ = new CGridGathererConnector(connectors) ;
+    clientFromClientConnector_ = make_shared<CGridGathererConnector>(connectors) ;
   }
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 2267)
@@ -328,20 +328,20 @@
 
       private:  
-        CGridLocalElements* gridLocalElements_= nullptr ;
+       shared_ptr<CGridLocalElements> gridLocalElements_= nullptr ;
         void computeGridLocalElements(void) ;
       public:
-        CGridLocalElements* getGridLocalElements(void) { if (gridLocalElements_==nullptr) computeGridLocalElements() ; return gridLocalElements_ ;}
-
-      private:
-        CGridLocalConnector* modelToWorkflowConnector_ = nullptr ;
+        shared_ptr<CGridLocalElements> getGridLocalElements(void) { if (gridLocalElements_==nullptr) computeGridLocalElements() ; return gridLocalElements_ ;}
+
+      private:
+        shared_ptr<CGridLocalConnector> modelToWorkflowConnector_ = nullptr ;
       public:
         void computeModelToWorkflowConnector(void) ;
-        CGridLocalConnector* getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_;}
-
-      private:
-        CGridLocalConnector* workflowToModelConnector_ = nullptr;
+        shared_ptr<CGridLocalConnector> getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_;}
+
+      private:
+        shared_ptr<CGridLocalConnector> workflowToModelConnector_ = nullptr;
       public:
         void computeWorkflowToModelConnector(void) ;
-        CGridLocalConnector* getWorkflowToModelConnector(void) { if (workflowToModelConnector_==nullptr) computeWorkflowToModelConnector() ; return workflowToModelConnector_;}
+        shared_ptr<CGridLocalConnector> getWorkflowToModelConnector(void) { if (workflowToModelConnector_==nullptr) computeWorkflowToModelConnector() ; return workflowToModelConnector_;}
 
       public: //? 
@@ -350,49 +350,49 @@
             
       private:
-        CGridLocalConnector* workflowToFullConnector_ = nullptr;
+        shared_ptr<CGridLocalConnector> workflowToFullConnector_ = nullptr;
       public:
         void computeWorkflowToFullConnector(void) ;
-        CGridLocalConnector* getWorkflowToFullConnector(void) { if (workflowToFullConnector_==nullptr) computeWorkflowToFullConnector() ; return workflowToFullConnector_;}
-
-      private:
-        CGridLocalConnector* fullToWorkflowConnector_ = nullptr;
+        shared_ptr<CGridLocalConnector> getWorkflowToFullConnector(void) { if (workflowToFullConnector_==nullptr) computeWorkflowToFullConnector() ; return workflowToFullConnector_;}
+
+      private:
+        shared_ptr<CGridLocalConnector> fullToWorkflowConnector_ = nullptr;
       public:
         void computeFullToWorkflowConnector(void) ;
-        CGridLocalConnector* getFullToWorkflowConnector(void) { if (fullToWorkflowConnector_==nullptr) computeFullToWorkflowConnector() ; return fullToWorkflowConnector_;}
+        shared_ptr<CGridLocalConnector> getFullToWorkflowConnector(void) { if (fullToWorkflowConnector_==nullptr) computeFullToWorkflowConnector() ; return fullToWorkflowConnector_;}
 
     
 
       private:
-         CGridGathererConnector* clientFromClientConnector_ = nullptr ;
-      public:
-         CGridGathererConnector* getClientFromClientConnector(void) { if (clientFromClientConnector_==nullptr) computeClientFromClientConnector() ; return clientFromClientConnector_;}
+         shared_ptr<CGridGathererConnector> clientFromClientConnector_ = nullptr ;
+      public:
+         shared_ptr<CGridGathererConnector> getClientFromClientConnector(void) { if (clientFromClientConnector_==nullptr) computeClientFromClientConnector() ; return clientFromClientConnector_;}
          void computeClientFromClientConnector(void) ;
 
       private:
-         map<CContextClient*, CGridScattererConnector*> clientToClientConnector_ ;
-      public:
-         CGridScattererConnector* getClientToClientConnector(CContextClient* client) { return clientToClientConnector_[client] ;} // make some test to see if connector exits for the given client
+         map<CContextClient*, shared_ptr<CGridScattererConnector>> clientToClientConnector_ ;
+      public:
+         shared_ptr<CGridScattererConnector> getClientToClientConnector(CContextClient* client) { return clientToClientConnector_[client] ;} // make some test to see if connector exits for the given client
   
 
       private:
-         map<CContextClient*,CGridGathererConnector*> clientFromServerConnector_  ;
-      public:
-         CGridGathererConnector* getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client];}
+         map<CContextClient*,shared_ptr<CGridGathererConnector>> clientFromServerConnector_  ;
+      public:
+         shared_ptr<CGridGathererConnector> getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client];}
          void computeClientFromServerConnector(void) ;
 
       private:
-         CGridScattererConnector* serverToClientConnector_=nullptr ;
-      public:
-         CGridScattererConnector* getServerToClientConnector(void) { if (serverToClientConnector_==nullptr) computeServerToClientConnector() ; return serverToClientConnector_;}
+         shared_ptr<CGridScattererConnector> serverToClientConnector_=nullptr ;
+      public:
+         shared_ptr<CGridScattererConnector> getServerToClientConnector(void) { if (serverToClientConnector_==nullptr) computeServerToClientConnector() ; return serverToClientConnector_;}
          void computeServerToClientConnector(void) ;
       private:
-         map<CContextClient*, CGridScattererConnector*> clientToServerConnector_ ;
-      public:
-         CGridScattererConnector* getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;} // make some test to see if connector exits for the given client
+         map<CContextClient*, shared_ptr<CGridScattererConnector>> clientToServerConnector_ ;
+      public:
+         shared_ptr<CGridScattererConnector> getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;} // make some test to see if connector exits for the given client
          
       private:
-         CGridGathererConnector* serverFromClientConnector_ = nullptr ;
-      public:
-         CGridGathererConnector* getServerFromClientConnector(void) { if (serverFromClientConnector_==nullptr) computeServerFromClientConnector() ; return serverFromClientConnector_;}
+         shared_ptr<CGridGathererConnector> serverFromClientConnector_ = nullptr ;
+      public:
+         shared_ptr<CGridGathererConnector> getServerFromClientConnector(void) { if (serverFromClientConnector_==nullptr) computeServerFromClientConnector() ; return serverFromClientConnector_;}
          void computeServerFromClientConnector(void) ;
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 2267)
@@ -346,5 +346,5 @@
       CArray<size_t,1> index(n) ;
       if (n==1) index(0)=0 ;
-      localElement_ = new CLocalElement(rank, 1, index) ;
+      localElement_ = make_shared<CLocalElement>(rank, 1, index) ;
    }
 
@@ -377,7 +377,7 @@
    void CScalar::computeModelToWorkflowConnector(void)
    { 
-     CLocalView* srcView=getLocalView(CElementView::MODEL) ;
-     CLocalView* dstView=getLocalView(CElementView::WORKFLOW) ;
-     modelToWorkflowConnector_ = new CLocalConnector(srcView, dstView); 
+     shared_ptr<CLocalView> srcView=getLocalView(CElementView::MODEL) ;
+     shared_ptr<CLocalView> dstView=getLocalView(CElementView::WORKFLOW) ;
+     modelToWorkflowConnector_ = make_shared<CLocalConnector>(srcView, dstView); 
      modelToWorkflowConnector_->computeConnector() ;
    }
@@ -409,10 +409,10 @@
       for (auto& rankServer : client->getRanksServerLeader()) globalIndex[rankServer].reference(indGlo.copy()) ; 
     }
-    remoteElement_[client] = new CDistributedElement(nglo, globalIndex) ;
+    remoteElement_[client] = make_shared<CDistributedElement>(nglo, globalIndex) ;
     remoteElement_[client]->addFullView() ;
   }
  
   void CScalar::distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, 
-                                   CScattererConnector* &scattererConnector, const string& scalarId)
+                                   shared_ptr<CScattererConnector> &scattererConnector, const string& scalarId)
   {
     string serverScalarId = scalarId.empty() ? this->getId() : scalarId ;
@@ -421,8 +421,8 @@
     this->sendAllAttributesToServer(client, serverScalarId)  ;
 
-    CDistributedElement scatteredElement(1,globalIndex) ;
-    scatteredElement.addFullView() ;
-    scattererConnector = new CScattererConnector(localElement_->getView(CElementView::FULL), scatteredElement.getView(CElementView::FULL), 
-                                                 context->getIntraComm(), client->getRemoteSize()) ;
+    auto scatteredElement = make_shared<CDistributedElement>(1,globalIndex) ;
+    scatteredElement->addFullView() ;
+    scattererConnector = make_shared<CScattererConnector>(localElement_->getView(CElementView::FULL), scatteredElement->getView(CElementView::FULL), 
+                                                          context->getIntraComm(), client->getRemoteSize()) ;
     scattererConnector->computeConnector() ;
     
@@ -441,13 +441,13 @@
     scattererConnector->transfer(localElement_->getView(CElementView::FULL)->getGlobalIndex(),client,event1,message1) ;
 
-    sendDistributedAttributes(client, *scattererConnector, scalarId) ;
+    sendDistributedAttributes(client, scattererConnector, scalarId) ;
   
     // phase 2 send the mask : data index + mask2D
     CArray<bool,1> maskIn(localElement_->getView(CElementView::WORKFLOW)->getSize());
     CArray<bool,1> maskOut ;
-    CLocalConnector workflowToFull(localElement_->getView(CElementView::WORKFLOW), localElement_->getView(CElementView::FULL)) ;
-    workflowToFull.computeConnector() ;
+    auto workflowToFull = make_shared<CLocalConnector>(localElement_->getView(CElementView::WORKFLOW), localElement_->getView(CElementView::FULL)) ;
+    workflowToFull->computeConnector() ;
     maskIn=true ;
-    workflowToFull.transfer(maskIn,maskOut,false) ;
+    workflowToFull->transfer(maskIn,maskOut,false) ;
 
     // phase 3 : prepare grid scatterer connector to send data from client to server
@@ -455,18 +455,18 @@
     map<int,CArray<bool,1>> maskOut2 ; 
     scattererConnector->transfer(maskOut, maskOut2) ;
-    scatteredElement.addView(CElementView::WORKFLOW, maskOut2) ;
-    scatteredElement.getView(CElementView::WORKFLOW)->getGlobalIndexView(workflowGlobalIndex) ;
+    scatteredElement->addView(CElementView::WORKFLOW, maskOut2) ;
+    scatteredElement->getView(CElementView::WORKFLOW)->getGlobalIndexView(workflowGlobalIndex) ;
     // create new workflow view for scattered element
-    CDistributedElement clientToServerElement(scatteredElement.getGlobalSize(), workflowGlobalIndex) ;
-    clientToServerElement.addFullView() ;
+    auto clientToServerElement = make_shared<CDistributedElement>(scatteredElement->getGlobalSize(), workflowGlobalIndex) ;
+    clientToServerElement->addFullView() ;
     CEventClient event2(getType(), EVENT_ID_SCALAR_DISTRIBUTION);
     CMessage message2 ;
     message2<<serverScalarId<<2 ; 
-    clientToServerElement.sendToServer(client, event2, message2) ; 
-    clientToServerConnector_[client] = new CScattererConnector(localElement_->getView(CElementView::WORKFLOW), clientToServerElement.getView(CElementView::FULL),
-                                                               context->getIntraComm(), client->getRemoteSize()) ;
+    clientToServerElement->sendToServer(client, event2, message2) ; 
+    clientToServerConnector_[client] = make_shared<CScattererConnector>(localElement_->getView(CElementView::WORKFLOW), clientToServerElement->getView(CElementView::FULL),
+                                                                        context->getIntraComm(), client->getRemoteSize()) ;
     clientToServerConnector_[client]->computeConnector() ;
 
-    clientFromServerConnector_[client] = new CGathererConnector(clientToServerElement.getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW));
+    clientFromServerConnector_[client] = make_shared<CGathererConnector>(clientToServerElement->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW));
     clientFromServerConnector_[client]->computeConnector() ;
 
@@ -489,5 +489,5 @@
     if (phasis==0) // receive the remote element to construct the full view
     {
-      localElement_ = new  CLocalElement(context->getIntraCommRank(),event) ;
+      localElement_ = make_shared<CLocalElement>(context->getIntraCommRank(),event) ;
       localElement_->addFullView() ;
       // construct the local dimension and indexes
@@ -499,7 +499,7 @@
     {
       CContext* context = CContext::getCurrent();
-      CDistributedElement* elementFrom = new  CDistributedElement(event) ;
+      shared_ptr<CDistributedElement> elementFrom = make_shared<CDistributedElement>(event) ;
       elementFrom->addFullView() ;
-      gathererConnector_ = new CGathererConnector(elementFrom->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
+      gathererConnector_ = make_shared<CGathererConnector>(elementFrom->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
       gathererConnector_->computeConnector() ; 
     }
@@ -507,7 +507,7 @@
     {
 //      delete gathererConnector_ ;
-      elementFrom_ = new  CDistributedElement(event) ;
+      elementFrom_ = make_shared<CDistributedElement>(event) ;
       elementFrom_->addFullView() ;
-//      gathererConnector_ =  new CGathererConnector(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
+//      gathererConnector_ =  make_shared<CGathererConnector>(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::FULL)) ;
 //      gathererConnector_ -> computeConnector() ;
     }
@@ -522,14 +522,14 @@
     if (serverMask.numElements()==1) mask = serverMask(0) ;
  
-    serverFromClientConnector_ = new CGathererConnector(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW)) ;
+    serverFromClientConnector_ = make_shared<CGathererConnector>(elementFrom_->getView(CElementView::FULL), localElement_->getView(CElementView::WORKFLOW)) ;
     serverFromClientConnector_->computeConnector() ;
       
-    serverToClientConnector_ = new CScattererConnector(localElement_->getView(CElementView::WORKFLOW), elementFrom_->getView(CElementView::FULL),
-                                                         context->getIntraComm(), client->getRemoteSize()) ;
+    serverToClientConnector_ = make_shared<CScattererConnector>(localElement_->getView(CElementView::WORKFLOW), elementFrom_->getView(CElementView::FULL),
+                                                                context->getIntraComm(), client->getRemoteSize()) ;
     serverToClientConnector_->computeConnector() ;
   }
   CATCH_DUMP_ATTR
 
-  void CScalar::sendDistributedAttributes(CContextClient* client, CScattererConnector& scattererConnector, const string& scalarId)
+  void CScalar::sendDistributedAttributes(CContextClient* client, shared_ptr<CScattererConnector> scattererConnector, const string& scalarId)
   {
     string serverScalarId = scalarId.empty() ? this->getId() : scalarId ;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 2266)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.hpp	(revision 2267)
@@ -175,10 +175,10 @@
     //////////////////////////////////////////////////////////////////////////////////////
     private:
-      CLocalElement* localElement_ = nullptr ;
+      shared_ptr<CLocalElement> localElement_ = nullptr ;
       void initializeLocalElement(void) ;
        
     public:  
-      CLocalElement* getLocalElement(void) { if (localElement_==nullptr) initializeLocalElement() ; return localElement_ ; }
-      CLocalView* getLocalView(CElementView::type type) { return getLocalElement()->getView(type) ;}
+      shared_ptr<CLocalElement> getLocalElement(void) { if (localElement_==nullptr) initializeLocalElement() ; return localElement_ ; }
+      shared_ptr<CLocalView> getLocalView(CElementView::type type) { return getLocalElement()->getView(type) ;}
        
     private:  
@@ -188,12 +188,12 @@
         
     private:
-      CLocalConnector* modelToWorkflowConnector_ ;
+      shared_ptr<CLocalConnector> modelToWorkflowConnector_ ;
       void computeModelToWorkflowConnector(void)  ;
     public:
-      CLocalConnector* getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_ ;}
+      shared_ptr<CLocalConnector> getModelToWorkflowConnector(void) { if (modelToWorkflowConnector_==nullptr) computeModelToWorkflowConnector() ; return modelToWorkflowConnector_ ;}
 
     public:
       void computeRemoteElement(CContextClient* client, EDistributionType) ;
-      void distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, CScattererConnector* &scattererConnector,
+      void distributeToServer(CContextClient* client, std::map<int, CArray<size_t,1>>& globalIndex, shared_ptr<CScattererConnector> &scattererConnector,
                                  const string& scalarId="") ;
 
@@ -201,36 +201,36 @@
       void receivedScalarDistribution(CEventServer& event, int phasis) ;
       void setServerMask(CArray<bool,1>& serverMask, CContextClient* client) ;
-      void sendDistributedAttributes(CContextClient* client, CScattererConnector& scattererConnector, const string& scalarId) ;
+      void sendDistributedAttributes(CContextClient* client, shared_ptr<CScattererConnector> scattererConnector, const string& scalarId) ;
       static void recvDistributedAttributes(CEventServer& event) ;
       void recvDistributedAttributes(CEventServer& event, const string& type) ;
 
     private:
-      map<CContextClient*, CDistributedElement*> remoteElement_ ;
-    public: 
-      CDistributedElement* getRemoteElement(CContextClient* client) {return remoteElement_[client] ;}
-    private:
-      map<CContextClient*, CScattererConnector*> clientToServerConnector_ ;
-    public: 
-      CScattererConnector* getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;}
-
-    private:
-      CGathererConnector*  gathererConnector_ ;
-    public:
-      CGathererConnector* getGathererConnector(void) { return gathererConnector_ ;}
-    private:
-      CGathererConnector* serverFromClientConnector_ ;
-      CDistributedElement* elementFrom_ ;
-    public:
-      CGathererConnector* getServerFromClientConnector(void) { return serverFromClientConnector_ ;}
-
-    private:
-      CScattererConnector*  serverToClientConnector_ = nullptr ;
-    public: 
-      CScattererConnector* getServerToClientConnector(void) { return serverToClientConnector_ ;} 
-
-    private:
-      map<CContextClient*,CGathererConnector*>  clientFromServerConnector_  ;
-    public: 
-      CGathererConnector* getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client] ;} 
+      map<CContextClient*, shared_ptr<CDistributedElement>> remoteElement_ ;
+    public: 
+      shared_ptr<CDistributedElement> getRemoteElement(CContextClient* client) {return remoteElement_[client] ;}
+    private:
+      map<CContextClient*, shared_ptr<CScattererConnector>> clientToServerConnector_ ;
+    public: 
+      shared_ptr<CScattererConnector> getClientToServerConnector(CContextClient* client) { return clientToServerConnector_[client] ;}
+
+    private:
+      shared_ptr<CGathererConnector>  gathererConnector_ ;
+    public:
+      shared_ptr<CGathererConnector> getGathererConnector(void) { return gathererConnector_ ;}
+    private:
+      shared_ptr<CGathererConnector> serverFromClientConnector_ ;
+      shared_ptr<CDistributedElement> elementFrom_ ;
+    public:
+      shared_ptr<CGathererConnector> getServerFromClientConnector(void) { return serverFromClientConnector_ ;}
+
+    private:
+     shared_ptr<CScattererConnector>  serverToClientConnector_ = nullptr ;
+    public: 
+      shared_ptr<CScattererConnector> getServerToClientConnector(void) { return serverToClientConnector_ ;} 
+
+    private:
+      map<CContextClient*,shared_ptr<CGathererConnector>>  clientFromServerConnector_  ;
+    public: 
+      shared_ptr<CGathererConnector> getClientFromServerConnector(CContextClient* client) { return clientFromServerConnector_[client] ;} 
 
     private:
